ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.20 by root, Mon Dec 13 17:35:51 2010 UTC vs.
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC

6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
12PERL_CC=cc 13PERL_CC=cc
13PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
14PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
15PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
16 17
17ARCH="$(uname -m)" 18ARCH="$(uname -m)"
18 19
19case "$ARCH" in 20case "$ARCH" in
20 i*86 | x86_64 | amd64 ) 21 i*86 | x86_64 | amd64 )
21 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
22 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
23 case "$ARCH" in 23 case "$ARCH" in
24 i*86 ) 24 i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;; 26 ;;
27 esac 27 esac
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 37
37# some configuration options for modules 38# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
41 44
42# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
43# required by mkbundle 46# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 48
46# which extra modules you might want to install 49# which extra modules you might want to install
47EXTRA_MODULES="" 50EXTRA_MODULES=""
48 51
49# overridable functions 52# overridable functions
50preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
51postconfigure() { : ; } 55postconfigure() { : ; }
52postbuild() { : ; } 56postbuild() { : ; }
53postinstall() { : ; } 57postinstall() { : ; }
54 58
55# now source user config, if any 59# now source user config, if any
62fi 66fi
63 67
64############################################################################# 68#############################################################################
65# support 69# support
66 70
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 72
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
71export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
72 80
73# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
75$VERSION=0.911 83$VERSION="1.21"
76 84
77BZ2=bz2 85BZ2=bz2
78BZIP2=bzip2 86BZIP2=bzip2
79 87
80fatal() { 88fatal() {
126 134
127clean() { 135clean() {
128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129} 137}
130 138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
143}
144
131fetch() { 145fetch() {
132 rcd "$STATICPERL" 146 rcd "$STATICPERL"
133 147
134 mkdir -p src 148 mkdir -p src
135 rcd src 149 rcd src
145perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
146trying $URL 160trying $URL
147EOF 161EOF
148 162
149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
152 || fatal "$URL: unable to download" 166 || fatal "$URL: unable to download"
153 rm -f perl-$PERL_VERSION.tar.$BZ2 167 rm -f perl-$PERL_VERSION.tar.$BZ2
154 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
155 fi 169 fi
156 170
158unpacking perl 172unpacking perl
159EOF 173EOF
160 174
161 mkdir -p unpack 175 mkdir -p unpack
162 rm -rf unpack/perl-$PERL_VERSION 176 rm -rf unpack/perl-$PERL_VERSION
163 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
164 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
165 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
166 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
167 rmdir -p unpack 181 rmdir -p unpack
168 fi 182 fi
169} 183}
173 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 187 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
174 rm -f "$2" 188 rm -f "$2"
175 mv "$2~" "$2" 189 mv "$2~" "$2"
176} 190}
177 191
192configure_failure() {
193 cat <<EOF
194
195
196***
197*** Configure failed - see above for the exact error message(s).
198***
199*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
200*** flags are not supported by your compiler. Less often, this is because
201*** PERL_LIBS either contains a library not available on your system (such as
202*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
203***
204*** You can provide your own flags by creating a ~/.staticperlrc file with
205*** variable assignments. For example (these are the actual values used):
206***
207
208PERL_CC="$PERL_CC"
209PERL_CCFLAGS="$PERL_CCFLAGS"
210PERL_OPTIMIZE="$PERL_OPTIMIZE"
211PERL_LDFLAGS="$PERL_LDFLAGS"
212PERL_LIBS="$PERL_LIBS"
213
214EOF
215 exit 1
216}
217
178configure() { 218configure() {
179 fetch 219 fetch
180 220
181 rcd "$STATICPERL/src/perl-$PERL_VERSION" 221 rcd "$STATICPERL/src/perl-$PERL_VERSION"
182 222
186configuring $STATICPERL/src/perl-$PERL_VERSION 226configuring $STATICPERL/src/perl-$PERL_VERSION
187EOF 227EOF
188 228
189 rm -f "$PERL_PREFIX/staticstamp.install" 229 rm -f "$PERL_PREFIX/staticstamp.install"
190 230
191 make distclean >/dev/null 2>&1 231 "$MAKE" distclean >/dev/null 2>&1
192 232
233 sedreplace '/^#define SITELIB/d' config_h.SH
234
193 # I hate them 235 # I hate them for this
194 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
195 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
196 238
197 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
198 244
199# trace configure \ 245# trace configure \
200 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
201 -Uuse64bitint \ 247 -Uuse64bitint \
202 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
204 -Uusethreads \ 250 -Uusethreads \
205 -Uuseithreads \ 251 -Uuseithreads \
206 -Uusemultiplicity \ 252 -Uusemultiplicity \
207 -Uusesfio \ 253 -Uusesfio \
208 -Uuseshrplib \ 254 -Uuseshrplib \
255 -Uinstallusrbinperl \
256 -A ccflags=" $PERL_CCFLAGS" \
209 -Dcc="$PERL_CC" \ 257 -Dcc="$PERL_CC" \
210 -Dcppflags="$PERL_CPPFLAGS" \
211 -Dccflags="-g2 -fno-strict-aliasing" \
212 -Doptimize="$PERL_OPTIMIZE" \ 258 -Doptimize="$PERL_OPTIMIZE" \
213 -Dldflags="$PERL_LDFLAGS" \ 259 -Dldflags="$PERL_LDFLAGS" \
214 -Dlibs="$PERL_LIBS" \ 260 -Dlibs="$PERL_LIBS" \
215 -Dprefix="$PERL_PREFIX" \ 261 -Dprefix="$PERL_PREFIX" \
216 -Dbin="$PERL_PREFIX/bin" \ 262 -Dbin="$PERL_PREFIX/bin" \
217 -Dprivlib="$PERL_PREFIX/lib" \ 263 -Dprivlib="$PERL_PREFIX/lib" \
218 -Darchlib="$PERL_PREFIX/lib" \ 264 -Darchlib="$PERL_PREFIX/lib" \
219 -Uusevendorprefix \ 265 -Uusevendorprefix \
220 -Dsitelib="$PERL_PREFIX/lib" \ 266 -Dsitelib="$PERL_PREFIX/lib" \
221 -Dsitearch="$PERL_PREFIX/lib" \ 267 -Dsitearch="$PERL_PREFIX/lib" \
222 -Usitelibexp \
223 -Uman1dir \ 268 -Uman1dir \
224 -Uman3dir \ 269 -Uman3dir \
225 -Usiteman1dir \ 270 -Usiteman1dir \
226 -Usiteman3dir \ 271 -Usiteman3dir \
227 -Dpager=/usr/bin/less \ 272 -Dpager=/usr/bin/less \
228 -Demail="$EMAIL" \ 273 -Demail="$EMAIL" \
229 -Dcf_email="$EMAIL" \ 274 -Dcf_email="$EMAIL" \
230 -Dcf_by="$EMAIL" \ 275 -Dcf_by="$EMAIL" \
231 $PERL_CONFIGURE \ 276 $PERL_CONFIGURE \
232 -Duseperlio \ 277 -Duseperlio \
233 -dE || fatal "Configure failed" 278 -dE || configure_failure
234 279
235 sedreplace ' 280 sedreplace '
236 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
237 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
238 ' config.sh 283 ' config.sh
239 284
285 patchconfig || fatal "patchconfig hook failed"
286
240 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
241 288
242 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
243 290
244 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
245} 303}
246 304
247build() { 305build() {
248 configure 306 configure
249 307
253building $STATICPERL/src/perl-$PERL_VERSION 311building $STATICPERL/src/perl-$PERL_VERSION
254EOF 312EOF
255 313
256 rm -f "$PERL_PREFIX/staticstamp.install" 314 rm -f "$PERL_PREFIX/staticstamp.install"
257 315
258 make || fatal "make: error while building perl" 316 "$MAKE" || fatal "make: error while building perl"
259 317
260 postbuild || fatal "postbuild hook failed" 318 postbuild || fatal "postbuild hook failed"
261} 319}
262 320
263install() { 321install() {
270EOF 328EOF
271 329
272 ln -sf "perl/bin/" "$STATICPERL/bin" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
273 ln -sf "perl/lib/" "$STATICPERL/lib" 331 ln -sf "perl/lib/" "$STATICPERL/lib"
274 332
333 mkdir "$STATICPERL/patched"
334
275 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
276 rm -rf "$PERL_PREFIX" # by this rm -rf 336 rm -rf "$PERL_PREFIX" # by this rm -rf
277 337
278 make install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
279 339
280 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
281 341
282 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
283 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
284make || exit 344#CAT make-install-make.sh
285
286if find blib/arch/auto -type f | grep -q -v .exists; then
287 echo Probably an XS module, rebuilding perl
288 if make perl; then
289 mv perl "$PERL_PREFIX"/bin/perl~ \
290 && rm -f "$PERL_PREFIX"/bin/perl \
291 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
292 make -f Makefile.aperl map_clean
293 else
294 make -f Makefile.aperl map_clean
295 exit 1
296 fi
297fi
298
299make install UNINST=1
300EOF 345EOF
301 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
302 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
303 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
304 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
305 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
306 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
307 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
308 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
309 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
310 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
311 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
312 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
313 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
314 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
315 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
316 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
317 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
318 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
319 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
320 375
321 touch "$PERL_PREFIX/staticstamp.install" 376 touch "$PERL_PREFIX/staticstamp.install"
322 fi 377 fi
342installing modules from CPAN 397installing modules from CPAN
343$@ 398$@
344EOF 399EOF
345 400
346 for mod in "$@"; do 401 for mod in "$@"; do
347 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
348 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
349 done 404 done
350 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
351} 406}
352 407
364 for mod in "$@"; do 419 for mod in "$@"; do
365 echo 420 echo
366 echo $mod 421 echo $mod
367 ( 422 (
368 rcd $mod 423 rcd $mod
369 make -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
370 make distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
371 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
372 make || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
373 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
374 make distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
375 exit 0 430 exit 0
376 ) || exit $? 431 ) || exit $?
377 done 432 done
378} 433}
379 434
410#CAT mkbundle 465#CAT mkbundle
411MKBUNDLE 466MKBUNDLE
412} 467}
413 468
414bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
415 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
416 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
417 CACHE="$STATICPERL/cache" 473 CACHE="$STATICPERL/cache"
418 mkdir -p "$CACHE" 474 mkdir -p "$CACHE"
419 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
427 command="${1#--}"; shift 483 command="${1#--}"; shift
428 case "$command" in 484 case "$command" in
429 version ) 485 version )
430 echo "staticperl version $VERSION" 486 echo "staticperl version $VERSION"
431 ;; 487 ;;
432 fetch | configure | build | install | clean | distclean) 488 fetch | configure | build | install | clean | realclean | distclean)
433 ( "$command" ) 489 ( "$command" ) || exit
434 ;; 490 ;;
435 instsrc ) 491 instsrc )
436 ( instsrc "$@" ) 492 ( instsrc "$@" ) || exit
437 exit 493 exit
438 ;; 494 ;;
439 instcpan ) 495 instcpan )
440 ( instcpan "$@" ) 496 ( instcpan "$@" ) || exit
497 exit
498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
441 exit 502 exit
442 ;; 503 ;;
443 cpan ) 504 cpan )
444 ( install ) 505 ( install ) || exit
445 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
446 exit 507 exit
447 ;; 508 ;;
448 mkbundle ) 509 mkbundle )
449 ( install ) 510 ( install ) || exit
450 bundle "$@" 511 bundle "$@"
451 exit 512 exit
452 ;; 513 ;;
453 mkperl ) 514 mkperl )
454 ( install ) 515 ( install ) || exit
455 bundle --perl "$@" 516 bundle --perl "$@"
456 exit 517 exit
457 ;; 518 ;;
458 mkapp ) 519 mkapp )
459 ( install ) 520 ( install ) || exit
460 bundle --app "$@" 521 bundle --app "$@"
461 exit 522 exit
462 ;; 523 ;;
463 help ) 524 help )
464 podusage 2 525 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines